From cc4d60ff5179bdfcad6cc7f1d814cf9987c49aea Mon Sep 17 00:00:00 2001
From: Felix Abecassis <felix.abecassis@gmail.com>
Date: Tue, 5 Nov 2013 11:50:14 +0100
Subject: [PATCH] Patch to reproduce CopyFromYv12 bug with DXVA.

---
 modules/codec/avcodec/dxva2.c |    8 ++++++++
 modules/video_chroma/copy.c   |    4 +++-
 2 files changed, 11 insertions(+), 1 deletion(-)

diff --git a/modules/codec/avcodec/dxva2.c b/modules/codec/avcodec/dxva2.c
index 330daf0..763d1d0 100644
--- a/modules/codec/avcodec/dxva2.c
+++ b/modules/codec/avcodec/dxva2.c
@@ -420,6 +420,14 @@ static int Extract(vlc_va_t *external, picture_t *picture, void *opaque,
         CopyFromNv12(picture, plane, pitch,
                      va->width, va->height,
                      &va->surface_cache);
+
+        uint8_t *plane2[3] = {
+	  picture->Y_PIXELS, picture->U_PIXELS, picture->V_PIXELS
+        };
+        size_t  pitch2[3] = {
+	  picture->Y_PITCH, picture->U_PITCH, picture->V_PITCH
+        };
+	CopyFromYv12(picture, plane2, pitch2, va->width, va->height, 0);
     }
 
     /* */
diff --git a/modules/video_chroma/copy.c b/modules/video_chroma/copy.c
index e0823aa..81da2d1 100644
--- a/modules/video_chroma/copy.c
+++ b/modules/video_chroma/copy.c
@@ -350,7 +350,7 @@ static void CopyPlane(uint8_t *dst, size_t dst_pitch,
                       unsigned width, unsigned height)
 {
     for (unsigned y = 0; y < height; y++) {
-        memcpy(dst, src, width);
+        memmove(dst, src, width);
         src += src_pitch;
         dst += dst_pitch;
     }
@@ -398,6 +398,7 @@ void CopyFromYv12(picture_t *dst, uint8_t *src[3], size_t src_pitch[3],
                   unsigned width, unsigned height,
                   copy_cache_t *cache)
 {
+  /*
 #ifdef CAN_COMPILE_SSE2
     unsigned cpu = vlc_CPU();
     if (vlc_CPU_SSE2())
@@ -406,6 +407,7 @@ void CopyFromYv12(picture_t *dst, uint8_t *src[3], size_t src_pitch[3],
 #else
     (void) cache;
 #endif
+  */
 
      CopyPlane(dst->p[0].p_pixels, dst->p[0].i_pitch,
                src[0], src_pitch[0], width, height);
-- 
1.7.10.4

